diff -Naur tomato119/tomato/release/src/router/httpd/tomato.c tomato121/tomato/release/src/router/httpd/tomato.c
--- tomato119/tomato/release/src/router/httpd/tomato.c	2008-04-21 05:21:20.000000000 +1000
+++ tomato121/tomato/release/src/router/httpd/tomato.c	2008-07-27 01:23:16.000000000 +1000
@@ -345,7 +345,7 @@
 	{ "ntp_kiss",			V_LENGTH(0, 255)	},
 
 // basic-static
-	{ "dhcpd_static",		V_LENGTH(0, 53*50)	},	// 53 (max chars per entry) x 50 entries
+	{ "dhcpd_static",		V_LENGTH(0, 53*101)	},	// 53 (max chars per entry) x 100 entries
 
 // basic-ddns
 	{ "ddnsx0",				V_LENGTH(0, 2048)	},
@@ -445,8 +445,9 @@
 	{ "dhcpd_dmdns",		V_01				},
 	{ "dns_addget",			V_01				},
 	{ "dns_intcpt",			V_01				},
-	{ "dnsmasq_custom",		V_TEXT(0, 2048)		},
 	{ "dhcpc_minpkt",		V_01				},
+	{ "dnsmasq_custom",		V_TEXT(0, 2048)		},
+//	{ "dnsmasq_norw",		V_01				},
 
 // advanced-firewall		// todo: moveme
 	{ "block_wan",			V_01				},
@@ -585,6 +586,7 @@
 	{ "debug_cprintf_file",	V_01				},
 //	{ "debug_keepfiles",	V_01				},
 	{ "debug_ddns",			V_01				},
+	{ "debug_norestart",	V_TEXT(0, 128)		},
 	{ "console_loglevel",	V_RANGE(1, 8)		},
 	{ "t_cafree",			V_01				},
 	{ "t_hidelr",			V_01				},
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/CHANGELOG tomato121/tomato/release/src/router/layer7/protocols/CHANGELOG
--- tomato119/tomato/release/src/router/layer7/protocols/CHANGELOG	2008-02-21 00:43:18.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/CHANGELOG	2008-04-23 23:23:44.000000000 +1000
@@ -1,3 +1,8 @@
+2008 04 23
+Testing for random matches with test_match.sh and the kernel library was 
+completely broken.  It now actually works.  Added includes to testing 
+programs for gcc 4.3 compatibility.  Updated qq.
+
 2008 02 20
 Added png.
 
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/file_types/png.pat tomato121/tomato/release/src/router/layer7/protocols/file_types/png.pat
--- tomato119/tomato/release/src/router/layer7/protocols/file_types/png.pat	2008-02-21 00:43:06.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/file_types/png.pat	2008-02-21 00:46:45.000000000 +1100
@@ -2,6 +2,8 @@
 # Pattern attributes: good fast notsofast subset
 # Protocol groups: file
 
+# Contributed by Radovan Josth.  Tested at least a bit.
+
 png
 # drawn from /usr/share/magic
 \x89PNG\x0d\x0a\x1a\x0a
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/protocols/qq.pat tomato121/tomato/release/src/router/layer7/protocols/protocols/qq.pat
--- tomato119/tomato/release/src/router/layer7/protocols/protocols/qq.pat	2006-12-12 03:16:55.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/protocols/qq.pat	2008-04-23 23:38:24.000000000 +1000
@@ -11,8 +11,15 @@
 # one is udp, and another is tcp
 # udp protocol: the first byte is 02 and last byte is 03
 # tcp protocol: the second byte is 02 and last byte is 03
+#   tony on protocolinfo.org says that now the *third* byte is 02:
+#     "but when I tested on my PC, I found that when qq2007/qq2008 
+#     use tcp protocol, the third byte instead of the second is always 02.
+#
+#     So the QQ protocol changed again, or I have made a mistake, I wonder 
+#     that."
+#   So now the pattern allows any of the first three bytes to be 02.  Delete
+#   one of the ".?" to restore to the old behaviour.
 # pattern written by www.routerclub.com wsgtrsys
 
 qq
-^.?\x02.+\x03$
-
+^.?.?\x02.+\x03$
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/testing/match-kernel.c tomato121/tomato/release/src/router/layer7/protocols/testing/match-kernel.c
--- tomato119/tomato/release/src/router/layer7/protocols/testing/match-kernel.c	2007-01-13 20:29:36.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/testing/match-kernel.c	2008-04-23 23:36:41.000000000 +1000
@@ -67,8 +67,8 @@
 	char input[MAX];
 	int patternlen, inputlen = 0, c = 0;
 
-	if(!argv[1]){
-		fprintf(stderr, "need an arg (the pattern)\n");
+	if(argc != 2 || !argv[1]){
+		fprintf(stderr, "need exactly one arg (the pattern)\n");
 		return 1;
 	}
 	patternlen = strlen(s);
@@ -77,6 +77,8 @@
 		return 1;
 	}
 
+//	fprintf(stderr, "\"%s\"", s);
+
 	s = pre_process(s); /* do \xHH escapes */
 
 	pattern = regcomp(s, &patternlen);
@@ -86,12 +88,27 @@
 		exit(1);
 	}
 
+/*
 	for(c = 0; c < MAX; c++){
 		// assumes there's plenty to eat
 		input[inputlen] = getchar();
 		inputlen++;
 	}
 	input[inputlen] = '\0';
+*/
+        for(c = 0; c < MAX; c++){
+                char temp = 0;
+                while(temp == 0){
+                        if(EOF == scanf("%c", &temp))
+                                goto out;
+                        input[c] = temp;
+                }
+        }
+        out:
+
+        input[c-1] = '\0';
+
+	inputlen = c;
 
 	for(c = 0; c < inputlen; c++)	input[c] = tolower(input[c]);
 
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/testing/test_match.sh tomato121/tomato/release/src/router/layer7/protocols/testing/test_match.sh
--- tomato119/tomato/release/src/router/layer7/protocols/testing/test_match.sh	2007-01-15 15:51:57.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/testing/test_match.sh	2008-04-24 12:41:00.000000000 +1000
@@ -6,7 +6,7 @@
 	# this can miss pseudo-valid files that have crap after the pattern
 		cat $1 | grep -v ^$ | grep -v ^# | tail -1
 	else
-		echo Arg is not a readable file > /dev/stderr
+		echo Argument is not a readable file > /dev/stderr
 		exit 1
 	fi
 }
@@ -17,9 +17,11 @@
 fi
 
 if [ ! $2 ]; then
+	echo
 	echo Using the userspace pattern and library.
-	echo You can change this by saying \"kernel\" as the second arg.
-	matchprog=./test_speed-userspace
+	echo You can change this by saying \"kernel\" as the second argument.
+	echo
+	matchprog=./test_speed-userspace # no, really
 elif [ $2 == "kernel" ]; then
 	echo Using the kernel pattern and library.
 	matchprog=./match_kernel
@@ -35,8 +37,10 @@
 	times=$3
 else
 	times=500
+	echo
 	echo Doing 500 repetitions of each test.
-	echo You can change this by giving a number as the third arg.
+	echo You can change this by giving a number as the third argument.
+	echo
 fi
 
 if [ -x ./randchars ] && [ -x $matchprog ] && [ -x ./randprintable ]; then
@@ -53,7 +57,7 @@
 
 for f in `seq $times`; do
 	if [ $3 ]; then printf . > /dev/stderr; fi
-	if [ $2 ] && [ $2 == "henry" ]; then
+	if [ $2 ] && [ $2 == "kernel" ]; then
 		if ! ./randchars | $matchprog "$pattern"; then exit 1; fi
 	else
 		if ! ./randchars | $matchprog -f $1 -n 1 -v; then exit 1; fi
@@ -64,9 +68,13 @@
 
 for f in `seq $times`; do
 	if [ $3 ]; then printf . > /dev/stderr; fi
-	if [ $2 ] && [ $2 == "henry" ]; then
-		if ! ./randprintable | $matchprog "$pattern"; then exit 1; fi
+	if [ $2 ] && [ $2 == "kernel" ]; then
+		if ! ./randprintable | $matchprog "$pattern"; then 
+                	exit 1
+		fi
 	else
-		if ! ./randprintable | $matchprog -v -n 1 -f $1; then exit 1; fi
+		if ! ./randprintable | $matchprog -v -n 1 -f $1; then 
+			exit 1
+		fi
 	fi
 done | grep -iE '^match' -c
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/testing/test_speed-kernel.c tomato121/tomato/release/src/router/layer7/protocols/testing/test_speed-kernel.c
--- tomato119/tomato/release/src/router/layer7/protocols/testing/test_speed-kernel.c	2007-01-13 20:49:00.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/testing/test_speed-kernel.c	2008-04-23 23:18:45.000000000 +1000
@@ -11,6 +11,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <stdlib.h>
 #include "regexp/regexp.c"
 
 #define MAX 1500
@@ -67,11 +68,9 @@
 	char input[MAX];
 	int c;
 
-	for(c = 0; c < MAX; c++)
-	{
+	for(c = 0; c < MAX; c++){
 		char temp = 0;
-		while(temp == 0)
-		{
+		while(temp == 0){
 			if(EOF == scanf("%c", &temp))
 				goto out;
 			input[c] = temp;
diff -Naur tomato119/tomato/release/src/router/layer7/protocols/testing/test_speed-userspace.cpp tomato121/tomato/release/src/router/layer7/protocols/testing/test_speed-userspace.cpp
--- tomato119/tomato/release/src/router/layer7/protocols/testing/test_speed-userspace.cpp	2007-01-15 16:41:27.000000000 +1100
+++ tomato121/tomato/release/src/router/layer7/protocols/testing/test_speed-userspace.cpp	2008-04-23 23:18:18.000000000 +1000
@@ -16,9 +16,10 @@
 #include <fstream>
 #include <iostream>
 #include <sys/types.h>
+#include <stdlib.h>
 #include "l7-parse-patterns.h"
 
-#define MAX 1500
+#define MAX 512
 
 static int hex2dec(char c)
 {
@@ -69,11 +70,9 @@
 	char input[MAX];
 	int c;
 
-	for(c = 0; c < MAX; c++)
-	{
+	for(c = 0; c < MAX; c++){
 		char temp = 0;
-		while(temp == 0)
-		{
+		while(temp == 0){
 			if(EOF == scanf("%c", &temp))
 				goto out;
 			input[c] = temp;
diff -Naur tomato119/tomato/release/src/router/mdu/mdu.c tomato121/tomato/release/src/router/mdu/mdu.c
--- tomato119/tomato/release/src/router/mdu/mdu.c	2008-04-21 05:21:27.000000000 +1000
+++ tomato121/tomato/release/src/router/mdu/mdu.c	2008-07-27 01:23:23.000000000 +1000
@@ -1265,6 +1265,56 @@
 
 /*
 
+	everydns.net
+
+HTTP/1.1 200 OK
+Server: Apache
+X-Powered-By: PHP/5.0.1-dev
+Connection: close
+Content-Type: text/html; charset=utf-8
+
+Authentication given
+Authentication failed: Bad Username/password
+Exit code: 2
+
+*/
+static void update_everydns(void)
+{
+	int r;
+	char *body;
+	char query[2048];
+	const char *p;
+	
+	strcpy(query, "/index.php?ver=0.1");
+	append_addr_option(query, "&ip=%s");
+	
+	p = get_option("host");
+	if (p) sprintf(query + strlen(query), "&domain=%s", p);
+	
+	r = wget(0, 0, "dyn.everydns.net", query, NULL, 1, &body);
+	if (r == 200) {
+		if ((p = strstr(body, "Exit code:")) != NULL) {
+			r = atoi(p + 10);
+			switch (r) {
+			case 0:
+				success();
+				break;
+			case 2:
+				error(M_INVALID_AUTH);
+				break;
+			default:
+				error(M_UNKNOWN_RESPONSE__D, r);
+				break;
+			}
+		}
+		error(M_UNKNOWN_RESPONSE__D, -1);
+	}
+	
+	error(M_UNKNOWN_ERROR__D, r);
+}
+
+/*
+
 	wget/custom
 
 */
@@ -1483,6 +1533,9 @@
 		// no account, test output ok, test 401 error parse ok 9/15 -- zzz
 		update_dua(NULL, 0, "members.easydns.com", "/dyn/dyndns.php", 1);
 	}
+	else if (strcmp(p, "seasydns") == 0) {
+		update_dua(NULL, 1, "members.easydns.com", "/dyn/dyndns.php", 1);
+	}
 	else if (strcmp(p, "3322") == 0) {
 		// no account, test output ok, test 401 error parse ok 9/16 -- zzz
 		update_dua(NULL, 0, "members.3322.org", "/dyndns/update", 1);
@@ -1536,6 +1589,10 @@
 		// test ok 9/16 -- zzz
 		update_afraid();
 	}
+	else if (strcmp(p, "everydns") == 0) {
+		// 07/2008 -- zzz
+		update_everydns();
+	}
 	else if ((strcmp(p, "wget") == 0) || (strcmp(p, "custom") == 0)) {
 		// test ok 9/15 -- zzz
 		update_wget();
diff -Naur tomato119/tomato/release/src/router/nvram/defaults.c tomato121/tomato/release/src/router/nvram/defaults.c
--- tomato119/tomato/release/src/router/nvram/defaults.c	2008-04-21 05:21:28.000000000 +1000
+++ tomato121/tomato/release/src/router/nvram/defaults.c	2008-07-27 01:23:24.000000000 +1000
@@ -276,10 +276,11 @@
 // advanced-dhcpdns
 	{ "dhcpd_dmdns",		"1"				},
 	{ "dhcpd_slt",			"0"				},
-	{ "dnsmasq_custom",		""				},
 	{ "dns_addget",			"0"				},
 	{ "dns_intcpt",			"0"				},
 	{ "dhcpc_minpkt",		"0"				},
+	{ "dnsmasq_custom",		""				},
+//	{ "dnsmasq_norw",		"0"				},
 
 // advanced-firewall
 //		{ "block_loopback",		"0"				},	// nat loopback
diff -Naur tomato119/tomato/release/src/router/rc/init.c tomato121/tomato/release/src/router/rc/init.c
--- tomato119/tomato/release/src/router/rc/init.c	2008-04-21 05:21:36.000000000 +1000
+++ tomato121/tomato/release/src/router/rc/init.c	2008-07-27 01:23:32.000000000 +1000
@@ -603,6 +603,19 @@
 		nvram_set("opo", "0x0008");
 		nvram_set("ag0", "0x0C");
 		break;	
+	case MODEL_WL500GPv2:
+		mfr = "Asus";
+		name = "WL-500gP v2";
+		//	features = ?;
+		if (!nvram_match("t_fix1", (char *)name)) {
+			if (nvram_match("vlan1ports", "4 5u")) {
+				nvram_set("vlan1ports", "4 5");
+			}
+			else if (nvram_match("vlan1ports", "0 5u")) {	// 520GU?
+				nvram_set("vlan1ports", "0 5");
+			}
+		}
+		break;
 #endif
 #if TOMATO_N
 	case MODEL_WZRG300N:
@@ -848,9 +861,7 @@
 
 		case IDLE:
 			while (signaled == -1) {
-				test_cron();
-				test_igmp();
-				
+				check_services();				
 				if ((!noconsole) && ((!shell_pid) || (kill(shell_pid, 0) != 0))) {
 					shell_pid = run_shell(0, 1);
 				}
diff -Naur tomato119/tomato/release/src/router/rc/rc.h tomato121/tomato/release/src/router/rc/rc.h
--- tomato119/tomato/release/src/router/rc/rc.h	2008-04-21 05:21:37.000000000 +1000
+++ tomato121/tomato/release/src/router/rc/rc.h	2008-07-27 01:23:33.000000000 +1000
@@ -149,7 +149,6 @@
 // services.c
 extern void start_cron(void);
 extern void stop_cron(void);
-extern void test_cron(void);
 extern void start_zebra(void);
 extern void stop_zebra(void);
 extern void start_upnp(void);
@@ -158,7 +157,6 @@
 extern void stop_syslog(void);
 extern void start_igmp_proxy(void);
 extern void stop_igmp_proxy(void);
-extern void test_igmp(void);
 extern void start_httpd(void);
 extern void stop_httpd(void);
 extern void clear_resolv(void);
@@ -168,8 +166,11 @@
 extern void set_tz(void);
 extern void start_ntpc(void);
 extern void stop_ntpc(void);
+extern void check_services(void);
 extern void exec_service(void);
 extern int service_main(int argc, char *argv[]);
+extern void start_service(const char *name);
+extern void stop_service(const char *name);
 extern void start_services(void);
 extern void stop_services(void);
 
diff -Naur tomato119/tomato/release/src/router/rc/services.c tomato121/tomato/release/src/router/rc/services.c
--- tomato119/tomato/release/src/router/rc/services.c	2008-04-21 05:21:37.000000000 +1000
+++ tomato121/tomato/release/src/router/rc/services.c	2008-07-27 01:23:33.000000000 +1000
@@ -50,6 +50,10 @@
 
 static const char dmhosts[] = "/etc/hosts.dnsmasq";
 static const char dmresolv[] = "/etc/resolv.dnsmasq";
+static const char dmpid[] = "/var/run/dnsmasq.pid";
+
+static pid_t pid_dnsmasq = -1;
+
 
 void start_dnsmasq()
 {
@@ -72,13 +76,23 @@
 	int dhcp_lease;
 	int do_dhcpd;
 	int do_dns;
-
-	_dprintf("%s\n", __FUNCTION__);
+	
+	if (getpid() != 1) {
+		start_service("dnsmasq");
+		return;
+	}
 
 	stop_dnsmasq();
 
 	if (nvram_match("wl_mode", "wet")) return;
-
+/*	
+	if (nvram_get_int("dnsmasq_norw")) {
+		if (f_exists("/etc/dnsmasq.conf")) {
+			syslog(LOG_INFO, "%s exists. Not rewriting.", "/etc/dnsmasq.conf");
+			goto RUN;
+		}
+	}
+*/
 	if ((f = fopen("/etc/dnsmasq.conf", "w")) == NULL) return;
 
 	lan_ifname = nvram_safe_get("lan_ifname");
@@ -86,17 +100,23 @@
 	strlcpy(lan, router_ip, sizeof(lan));
 	if ((p = strrchr(lan, '.')) != NULL) *(p + 1) = 0;
 
-	fprintf(f, "interface=%s\n", lan_ifname);
+	fprintf(f, 
+		"pid-file=%s\n"
+		"interface=%s\n",
+		dmpid, lan_ifname);
 	if (((nv = nvram_get("wan_domain")) != NULL) || ((nv = nvram_get("wan_get_domain")) != NULL)) {
 		if (*nv) fprintf(f, "domain=%s\n", nv);
 	}
 
 	// dns
+	if (((nv = nvram_get("dns_minport")) != NULL) && (*nv)) n = atoi(nv);
+		else n = 4096;
 	fprintf(f,
 		"resolv-file=%s\n"		// the real stuff is here
 		"addn-hosts=%s\n"		// "
-		"expand-hosts\n",		// expand hostnames in hosts file
-		dmresolv, dmhosts);
+		"expand-hosts\n"		// expand hostnames in hosts file
+		"min-port=%u\n", 		// min port used for random src port
+		dmresolv, dmhosts, n);
 	do_dns = nvram_match("dhcpd_dmdns", "1");
 
 
@@ -201,20 +221,48 @@
 
 	if (hf) fclose(hf);
 
-	fprintf(f, "%s\n", nvram_safe_get("dnsmasq_custom"));
+	//
+	
+	fprintf(f, "%s\n\n", nvram_safe_get("dnsmasq_custom"));
+
+	//
+
+	FILE *af;
+
+	fflush(f);
+	if ((af = fopen("/etc/dnsmasq.custom", "r")) != NULL) {
+		while ((n = fread(buf, 1, sizeof(buf), af)) > 0) {
+			fwrite(buf, 1, n, f);
+		}
+		fclose(af);
+	}
+	
+	//
+	
 	fclose(f);
 
 	if (do_dns) {
 		unlink("/etc/resolv.conf");
 		symlink("/rom/etc/resolv.conf", "/etc/resolv.conf");	// nameserver 127.0.0.1
 	}
-	
-	xstart("dnsmasq");
+
+//	RUN:	
+	eval("dnsmasq");
+
+	if (!nvram_contains_word("debug_norestart", "dnsmasq")) {
+		f_read_string(dmpid, buf, sizeof(buf));
+		pid_dnsmasq = atol(buf);
+	}
 }
 
 void stop_dnsmasq(void)
 {
-	_dprintf("%s\n", __FUNCTION__);
+	if (getpid() != 1) {
+		stop_service("dnsmasq");
+		return;
+	}
+
+	pid_dnsmasq = -1;
 
 	unlink("/etc/resolv.conf");
 	symlink(dmresolv, "/etc/resolv.conf");
@@ -323,7 +371,7 @@
 	if (nvram_contains_word("log_events", "crond")) argv[1] = NULL;
 	_eval(argv, NULL, 0, NULL);
 	
-	if (!nvram_contains_word("wdg_norestart", "crond")) {
+	if (!nvram_contains_word("debug_norestart", "crond")) {
 		pid_crond = -2;	// intentionally fail test_cron()
 	}
 }
@@ -337,21 +385,6 @@
 	killall_tk("crond");
 }
 
-#if 1
-// bleh -- zzz
-void test_cron(void)
-{
-	// test ok 09/25	-- zzz
-	if (pid_crond != -1) {
-		if (kill(pid_crond, 0) != 0) {
-			if ((pid_crond = pidof("crond")) == -1) {
-				start_cron();
-			}
-		}
-	}
-}
-#endif
-
 // -----------------------------------------------------------------------------
 
 // Written by Sparq in 2002/07/16
@@ -493,7 +526,7 @@
 		}
 		xstart("igmprt", "-f", "-i", nvram_safe_get(p));
 		
-		if (!nvram_contains_word("wdg_norestart", "igmp")) {
+		if (!nvram_contains_word("debug_norestart", "igmprt")) {
 			pid_igmp = -2;
 		}
 	}
@@ -505,16 +538,6 @@
 	killall("igmprt", SIGTERM);
 }
 
-void test_igmp(void)
-{
-	if (pid_igmp != -1) {
-		if (kill(pid_igmp, 0) != 0) {
-			if ((pid_igmp = pidof("igmprt")) == -1) {
-				start_igmp_proxy();
-			}
-		}
-	}
-}
 
 // -----------------------------------------------------------------------------
 
@@ -564,6 +587,24 @@
 
 // -----------------------------------------------------------------------------
 
+static void _check(pid_t *pid, const char *name, void (*func)(void) )
+{
+	if (*pid != -1) {
+		if (kill(*pid, 0) != 0) {
+			if ((*pid = pidof(name)) == -1) func();
+		}
+	}
+}
+
+void check_services(void)
+{
+	_check(&pid_dnsmasq, "dnsmasq", start_dnsmasq);
+	_check(&pid_crond, "crond", start_cron);
+	_check(&pid_igmp, "igmprt", start_igmp_proxy);
+}
+
+// -----------------------------------------------------------------------------
+
 void start_services(void)
 {
 	static int once = 1;
@@ -932,31 +973,50 @@
 	nvram_set("action_service", "");
 }
 
-
-int service_main(int argc, char *argv[])
+static void do_service(const char *name, const char *action, int user)
 {
+	int n;
 	char s[64];
-
-	if (argc != 3) usage_exit(argv[0], "<service> <action>");
-
+	
+	n = 15;
 	while (!nvram_match("action_service", "")) {
-		putchar('*');
-		fflush(stdout);
+		if (user) {
+			putchar('*');
+			fflush(stdout);
+		}
+		else if (--n < 0) break;
 		sleep(1);
 	}
 	
-	snprintf(s, sizeof(s), "%s-%s", argv[1], argv[2]);
+	snprintf(s, sizeof(s), "%s-%s", name, action);
 	nvram_set("action_service", s);
 	kill(1, SIGUSR1);
 
+	n = 15;
 	while (nvram_match("action_service", s)) {
-		putchar('.');
-		fflush(stdout);
+		if (user) {
+			putchar('.');
+			fflush(stdout);
+		}
+		else if (--n < 0) break;
 		sleep(1);
 	}
-	
+}
+
+int service_main(int argc, char *argv[])
+{
+	if (argc != 3) usage_exit(argv[0], "<service> <action>");
+	do_service(argv[1], argv[2], 1);
 	printf("\nDone.\n");
 	return 0;
 }
 
+void start_service(const char *name)
+{
+	do_service(name, "start", 0);
+}
 
+void stop_service(const char *name)
+{
+	do_service(name, "stop", 0);
+}
diff -Naur tomato119/tomato/release/src/router/rc/telssh.c tomato121/tomato/release/src/router/rc/telssh.c
--- tomato119/tomato/release/src/router/rc/telssh.c	2008-04-21 05:21:37.000000000 +1000
+++ tomato121/tomato/release/src/router/rc/telssh.c	2008-07-27 01:23:33.000000000 +1000
@@ -84,7 +84,28 @@
 		}
 	}
 
+/*
 	xstart("dropbear", "-p", nvram_safe_get("sshd_port"), nvram_get_int("sshd_pass") ? "" : "-s");
+*/
+
+	char *argv[8];
+	int argc;
+	char *p;
+	
+	argv[0] = "dropbear";
+	argv[1] = "-p";
+	argv[2] = nvram_safe_get("sshd_port");
+	argc = 3;
+
+	if (!nvram_get_int("sshd_pass")) argv[argc++] = "-s";
+	
+	if (((p = nvram_get("sshd_rwb")) != NULL) && (*p)) {
+		argv[argc++] = "-W";
+		argv[argc++] = p;
+	}
+
+	argv[argc] = NULL;
+	_eval(argv, NULL, 0, NULL);
 }
 
 void stop_sshd(void)
diff -Naur tomato119/tomato/release/src/router/shared/id.c tomato121/tomato/release/src/router/shared/id.c
--- tomato119/tomato/release/src/router/shared/id.c	2008-04-21 05:21:38.000000000 +1000
+++ tomato121/tomato/release/src/router/shared/id.c	2008-07-27 01:23:34.000000000 +1000
@@ -48,6 +48,10 @@
 *WL-500G Deluxe		                      bcm95365r    45        0x10                  hardware_version=WL500gd-01-04-01-50 regulation_domain=0x30DE sdram_init=0x2008
 WL-500G Premium		BCM4704_BCM5325F      0x042f       45        0x10      0x0110      hardware_version=WL500gp-01-02-00-00 regulation_domain=0X10US sdram_init=0x0009
 WL-500G Premium		BCM4704_BCM5325F      0x042f       45        0x10      0x0110      hardware_version=WL500gH-01-00-00-00 regulation_domain=0X30DE sdram_init=0x000b
+
+WL-500G Premium v2  HW_BCM5354G           0x48E        45        0x10      0x0750
+WL-520GU			HW_BCM5354G           0x48E        45        0x10      0x0750
+
 WL-550gE			BCM5352E              0x0467       45        0x10      0x0758      hardware_version=WL550gE-01-05-01-00 sdram_init=0x2000
 
 *WL-700gE			BCM4704_BCM5325F      0x042f       44        0x10      0x0110      hardware_version=WL700g-01-10-01-00 regulation_domain=0X30DE
@@ -191,6 +195,8 @@
 			return MODEL_WL500GP;
 		case HW_BCM5352E:
 			return MODEL_WL500GE;
+		case HW_BCM5354G:
+			return MODEL_WL500GPv2;
 		}
 		break;
 	case 2:
diff -Naur tomato119/tomato/release/src/router/shared/shared.h tomato121/tomato/release/src/router/shared/shared.h
--- tomato119/tomato/release/src/router/shared/shared.h	2008-04-21 05:21:38.000000000 +1000
+++ tomato121/tomato/release/src/router/shared/shared.h	2008-07-27 01:23:34.000000000 +1000
@@ -74,6 +74,7 @@
 	MODEL_WR850GV2,
 	MODEL_WZRG54,
 	MODEL_WL500GP,
+	MODEL_WL500GPv2,
 	MODEL_WL500GE,
 	MODEL_WBRG54,
 	MODEL_WBR2G54,
@@ -178,5 +179,6 @@
 
 // strings.c
 extern const char *find_word(const char *buffer, const char *word);
+extern int remove_word(char *buffer, const char *word);
 
 #endif
diff -Naur tomato119/tomato/release/src/router/shared/strings.c tomato121/tomato/release/src/router/shared/strings.c
--- tomato119/tomato/release/src/router/shared/strings.c	2008-04-21 05:21:38.000000000 +1000
+++ tomato121/tomato/release/src/router/shared/strings.c	2008-07-27 01:23:34.000000000 +1000
@@ -44,3 +44,19 @@
 	strlcat(buffer, word, max);
 }
 */
+
+int remove_word(char *buffer, const char *word)
+{
+	char *p;
+	char *q;
+	
+	if ((p = strstr(buffer, word)) == NULL) return 0;
+	q = p;
+	p += strlen(word);
+	while (*p == ' ') ++p;
+	while ((q > buffer) && (*(q - 1) == ' ')) --q;
+	if (*q != 0) *q++ = ' ';
+	strcpy(q, p);
+
+	return 1;
+}
diff -Naur tomato119/tomato/release/src/router/shared/tomato_version tomato121/tomato/release/src/router/shared/tomato_version
--- tomato119/tomato/release/src/router/shared/tomato_version	2008-04-21 05:21:56.000000000 +1000
+++ tomato121/tomato/release/src/router/shared/tomato_version	2008-07-27 01:23:50.000000000 +1000
@@ -1 +1 @@
-1.19.0000
\ No newline at end of file
+1.21.0000
\ No newline at end of file
diff -Naur tomato119/tomato/release/src/router/www/admin-debug.asp tomato121/tomato/release/src/router/www/admin-debug.asp
--- tomato119/tomato/release/src/router/www/admin-debug.asp	2008-04-21 05:21:41.000000000 +1000
+++ tomato121/tomato/release/src/router/www/admin-debug.asp	2008-07-27 01:23:37.000000000 +1000
@@ -22,7 +22,7 @@
 
 <script type='text/javascript'>
 
-//	<% nvram("debug_nocommit,debug_cprintf,debug_cprintf_file,console_loglevel,t_cafree,t_hidelr,debug_ddns"); %>
+//	<% nvram("debug_nocommit,debug_cprintf,debug_cprintf_file,console_loglevel,t_cafree,t_hidelr,debug_ddns,debug_norestart"); %>
 
 function nvramCommit()
 {
@@ -44,6 +44,13 @@
 	fom.t_cafree.value = fom.f_cafree.checked ? 1 : 0;
 	fom.t_hidelr.value = fom.f_hidelr.checked ? 1 : 0;
 	fom.debug_ddns.value = fom.f_debug_ddns.checked ? 1 : 0;
+	
+	var a = [];
+	if (fom.f_nr_crond.checked) a.push('crond');
+	if (fom.f_nr_dnsmasq.checked) a.push('dnsmasq');
+	if (fom.f_nr_igmprt.checked) a.push('igmprt');
+	fom.debug_norestart.value = a.join(',');	
+	
 	form.submit(fom, 1);
 }
 </script>
@@ -68,6 +75,7 @@
 <input type='hidden' name='debug_cprintf'>
 <input type='hidden' name='debug_cprintf_file'>
 <input type='hidden' name='debug_ddns'>
+<input type='hidden' name='debug_norestart'>
 <input type='hidden' name='t_cafree'>
 <input type='hidden' name='t_hidelr'>
 
@@ -83,7 +91,12 @@
 	{ title: 'Enable DDNS output to /tmp/mdu-*', name: 'f_debug_ddns', type: 'checkbox', value: nvram.debug_ddns != '0' },
 	{ title: 'Count cache memory as free memory', name: 'f_cafree', type: 'checkbox', value: nvram.t_cafree == '1' },
 	{ title: 'Avoid displaying LAN to router connections', name: 'f_hidelr', type: 'checkbox', value: nvram.t_hidelr == '1' },
-	{ title: 'Console log level', name: 'console_loglevel', type: 'select', options: a, value: fixInt(nvram.console_loglevel, 1, 8, 1) }
+	{ title: 'Console log level', name: 'console_loglevel', type: 'select', options: a, value: fixInt(nvram.console_loglevel, 1, 8, 1) },
+	{ title: 'Do not restart the following process if they die', multi: [
+		{ name: 'f_nr_crond', type: 'checkbox', suffix: ' crond<br>', value: (nvram.debug_norestart.indexOf('crond') != -1) },
+		{ name: 'f_nr_dnsmasq', type: 'checkbox', suffix: ' dnsmasq<br>', value: (nvram.debug_norestart.indexOf('dnsmasq') != -1) },
+		{ name: 'f_nr_igmprt', type: 'checkbox', suffix: ' igmprt<br>', value: (nvram.debug_norestart.indexOf('igmprt') != -1) }
+	] }
 ]);
 </script>
 <br><br>
diff -Naur tomato119/tomato/release/src/router/www/admin-sched.asp tomato121/tomato/release/src/router/www/admin-sched.asp
--- tomato119/tomato/release/src/router/www/admin-sched.asp	2008-04-21 05:21:41.000000000 +1000
+++ tomato121/tomato/release/src/router/www/admin-sched.asp	2008-07-27 01:23:37.000000000 +1000
@@ -194,7 +194,7 @@
 	s += ',';
 	
 	e = E(k + 'time').value;
-	if (e == 'e') s += E(k + 'every').value;
+	if (e == 'e') s += -(E(k + 'every').value * 1);
 		else s += e;
 	
 	n = 0;
diff -Naur tomato119/tomato/release/src/router/www/advanced-dhcpdns.asp tomato121/tomato/release/src/router/www/advanced-dhcpdns.asp
--- tomato119/tomato/release/src/router/www/advanced-dhcpdns.asp	2008-04-21 05:21:41.000000000 +1000
+++ tomato121/tomato/release/src/router/www/advanced-dhcpdns.asp	2008-07-27 01:23:37.000000000 +1000
@@ -29,7 +29,7 @@
 
 <script type='text/javascript'>
 
-//	<% nvram("dhcpd_dmdns,dns_addget,dns_intcpt,dhcpd_slt,dnsmasq_custom,dhcpc_minpkt"); %>
+//	<% nvram("dhcpd_dmdns,dns_addget,dns_intcpt,dhcpd_slt,dhcpc_minpkt,dnsmasq_custom,dnsmasq_norw"); %>
 
 function verifyFields(focused, quiet)
 {
@@ -60,7 +60,7 @@
 	}
 	else {
 		fom._service.value = 'dnsmasq-restart';
-	}	
+	}
 	
 	if (fom.dns_intcpt.value != nvram.dns_intcpt) {
 		nvram.dns_intcpt = fom.dns_intcpt.value;
@@ -104,12 +104,15 @@
 	{ title: 'Static Lease Time', multi: [
 		{ name: 'f_dhcpd_sltsel', type: 'select', options: [[0,'Same as normal lease time'],[-1,'Infinite'],[1,'Custom']],
 			value: (nvram.dhcpd_slt < 1) ? nvram.dhcpd_slt : 1 },
-		{ name: 'f_dhcpd_slt', type: 'text', maxlen: 5, size: 8, prefix:	'<span id="_dhcpd_sltman"> ', suffix: ' <i>(minutes)</i></span>',
+		{ name: 'f_dhcpd_slt', type: 'text', maxlen: 5, size: 8, prefix: '<span id="_dhcpd_sltman"> ', suffix: ' <i>(minutes)</i></span>',
 			value: (nvram.dhcpd_slt >= 1) ? nvram.dhcpd_slt : 3600 } ] },
 	{ title: '<a href="http://www.thekelleys.org.uk/" target="_new">Dnsmasq</a><br>Custom Configuration', name: 'dnsmasq_custom', type: 'textarea', value: nvram.dnsmasq_custom }
 ]);
 </script>
+<br>
+Note: The file /etc/dnsmasq.custom is also added to the end of Dnsmasq's configuration file if it exists.
 </div>
+<br>
 
 <div class='section-title'>DHCP Client (WAN)</div>
 <div class='section'>
diff -Naur tomato119/tomato/release/src/router/www/basic-ddns.asp tomato121/tomato/release/src/router/www/basic-ddns.asp
--- tomato119/tomato/release/src/router/www/basic-ddns.asp	2008-04-21 05:21:42.000000000 +1000
+++ tomato121/tomato/release/src/router/www/basic-ddns.asp	2008-07-27 01:23:38.000000000 +1000
@@ -30,6 +30,7 @@
 t = hostname (top)
 u = username/password
 h = hostname
+j = hostname (optional)
 c = custom url
 w = wildcard
 m = MX
@@ -54,6 +55,8 @@
 	['sdyndns-custom', 'DynDNS (https) - Custom', 'http://www.dyndns.com/', 'uhwmb'],
 	['dyns', 'DyNS', 'http://www.dyns.cx/', 'uh'],
 	['easydns', 'easyDNS', 'http://www.easydns.com/', 'uhwm'],
+	['seasydns', 'easyDNS (https)', 'http://www.easydns.com/', 'uhwm'],
+	['everydns', 'EveryDNS', 'http://www.everydns.net/', 'uj', null, null, 'Domain <small>(optional)</small>'],
 	['enom', 'eNom', 'http://www.enom.com/', 'ut', 'Domain'],
 	['afraid', 'FreeDNS (afraid.org)', 'http://freedns.afraid.org/', 'az'],
 	['ieserver', 'ieServer.net', 'http://www.ieserver.net/', 'uhz', 'Username / Hostname', null, 'Domain'],
@@ -122,7 +125,7 @@
 
 		elem.display(PR('_f_hosttop' + i), op.t);
 		elem.display(PR('_f_user' + i), PR('_f_pass' + i), op.u);
-		elem.display(PR('_f_host' + i), op.h);
+		elem.display(PR('_f_host' + i), op.h || op.j);
 		elem.display(PR('_f_cust' + i), 'custmsg' + i, op.c);
 		
 		elem.display(PR('_f_wild' + i), op.w);
@@ -242,7 +245,7 @@
 			if (op.t) {
 				s.push(E('_f_hosttop' + i).value);
 			}
-			else if (op.h) {
+			else if ((op.h) || (op.j)) {
 				s.push(E('_f_host' + i).value);
 			}
 			else {
diff -Naur tomato119/tomato/release/src/router/www/basic-static.asp tomato121/tomato/release/src/router/www/basic-static.asp
--- tomato119/tomato/release/src/router/www/basic-static.asp	2008-04-21 05:21:42.000000000 +1000
+++ tomato121/tomato/release/src/router/www/basic-static.asp	2008-07-27 01:23:38.000000000 +1000
@@ -205,7 +205,7 @@
 
 sg.setup = function()
 {
-	this.init('bs-grid', 'sort', 50,
+	this.init('bs-grid', 'sort', 100,
 		[{ type: 'text', maxlen: 17 }, { type: 'text', maxlen: 15 }, { type: 'text', maxlen: 32 }]);
 	this.headerSet(['MAC Address', 'IP Address', 'Hostname']);
 	var s = nvram.dhcpd_static.split('>');
diff -Naur tomato119/tomato/release/src/router/www/bwm-daily.asp tomato121/tomato/release/src/router/www/bwm-daily.asp
--- tomato119/tomato/release/src/router/www/bwm-daily.asp	2008-04-21 05:21:42.000000000 +1000
+++ tomato121/tomato/release/src/router/www/bwm-daily.asp	2008-07-27 01:23:38.000000000 +1000
@@ -38,7 +38,7 @@
 
 function save()
 {
-	cookie.set('daily', scale, 14);
+	cookie.set('daily', scale, 31);
 }
 
 function redraw()
@@ -61,7 +61,7 @@
 		mo = ((h[0] >>> 8) & 0xFF);
 		da = (h[0] & 0xFF);
 
-		grid += makeRow(((rows & 1) ? 'odd' : 'even'), months[mo] + ' ' + da + ', ' + yr, rescale(h[1]), rescale(h[2]), rescale(h[1] + h[2]));
+		grid += makeRow(((rows & 1) ? 'odd' : 'even'), ymdText(yr, mo, da), rescale(h[1]), rescale(h[2]), rescale(h[1] + h[2]));
 		++rows;
 	}
 
@@ -79,7 +79,8 @@
 			E('scale').value = scale = RegExp.$1 * 1;
 		}
 	}
-
+	
+	initDate('ymd');	
 	daily_history.sort(cmpHist);
 	redraw();
 }
@@ -102,6 +103,7 @@
 <div class='section-title'>WAN Bandwidth - Daily</div>
 <div id='bwm-daily-grid' style='float:left'></div>
 <div style="float:right;text-align:right">
+<b>Date</b> <select onchange='changeDate(this, "ymd")' id='dafm'><option value=0>yyyy-mm-dd</option><option value=1>mm-dd-yyyy</option><option value=2>mmm dd, yyyy</option><option value=3>dd.mm.yyyy</option></select><br>
 <b>Scale</b> <select onchange='changeScale(this)' id='scale'><option value=0>KB</option><option value=1>MB</option><option value=2 selected>GB</option></select><br>
 <br>
 &raquo; <a href="admin-bwm.asp">Configure</a>
